---
# This workflow integrates ShiftLeft with GitHub
# Visit https://docs.shiftleft.io for help
name: ShiftLeft

on:
  pull_request:
  workflow_dispatch:

jobs:
  NextGen-Static-Analysis:
    runs-on: ubuntu-latest    
    steps:
    - uses: actions/checkout@v2
    - name: Setup Java JDK
      uses: actions/setup-java@v1.4.3
      with:
        java-version: 1.8
    - name: Download ShiftLeft cli
      run: |
        curl https://cdn.shiftleft.io/download/sl > ${GITHUB_WORKSPACE}/sl && chmod a+rx ${GITHUB_WORKSPACE}/sl
    - name: Extract branch name
      shell: bash
      run: echo "##[set-output name=branch;]$(echo ${GITHUB_REF#refs/heads/})"
      id: extract_branch
    - name: Build and Analyze
      run: |
        TARGET_DIR=target
        BUILT=0
        POM_COUNT=$(find . -maxdepth 1 -type f -name "pom.xml" -not -path '*/\.git/*' | wc -l | tr -d " ")
        GRADLE_COUNT=$(find . -maxdepth 1 -type f -name "build.gradle" -not -path '*/\.git/*' | wc -l | tr -d " ")
        SBT_COUNT=$(find . -maxdepth 1 -type f -name "build.sbt" -not -path '*/\.git/*' | wc -l | tr -d " ")
        if [ "$POM_COUNT" != "0" ]; then
          mvn compile package
          BUILT=1
        elif [ "$GRADLE_COUNT" != "0" ]; then
          gradle jar
          #./gradlew jar
          TARGET_DIR=build
          BUILT=1
        elif [ "$SBT_COUNT" != "0" ]; then
          echo "deb https://dl.bintray.com/sbt/debian /" | sudo tee -a /etc/apt/sources.list.d/sbt.list
          curl -sL "https://keyserver.ubuntu.com/pks/lookup?op=get&search=0x2EE0EA64E40A89B84B2DF73499E82A75642AC823" | sudo apt-key add
          sudo apt update -y
          sudo apt-get install sbt -y
          sbt package
          BUILT=1
        fi
        if [ "$BUILT" = "1" ] && [ -d "$TARGET_DIR" ]; then
          jar cvf app.jar -C $TARGET_DIR .
          docker build -t vuln_spring .
          ${GITHUB_WORKSPACE}/sl analyze --wait --app $(basename $(pwd)) --tag branch=${{ github.head_ref || steps.extract_branch.outputs.branch }} --java --container vuln_spring --cpg app.jar
          ${GITHUB_WORKSPACE}/sl check-analysis --app $(basename $(pwd)) --v2 --config shiftleft.yml \
            --source tag.branch=master --branch "${{ github.head_ref || steps.extract_branch.outputs.branch }}" \
            --report \
            --github-pr-number=${{github.event.number}} \
            --github-pr-user=${{ github.repository_owner }} \
            --github-pr-repo=${{ github.event.repository.name }} \
            --github-token=${{ secrets.GITHUB_TOKEN }}
          # ${GITHUB_WORKSPACE}/sl check-analysis --app $(basename $(pwd)) --v2 --config shiftleft.yml
        else
          echo "Unable to build the project automatically. Please follow the instructions in our documentation to setup this project - https://docs.shiftleft.io/ngsast/analyzing-applications/java"  
        fi
      env:
        SHIFTLEFT_ACCESS_TOKEN: ${{ secrets.SHIFTLEFT_ACCESS_TOKEN }}
        SL_CPG_OPTS: "-J-Xms2g -J-Xmx7g"
        SHIFTLEFT_JAVA_OPTS: "-Xms2g -Xmx7g"
